#ifndef MEMLEAK_HEADER
#define MEMLEAK_HEADER

// user can define the following or not:
#define CHECK_MEMORY_LEAK




//----------------------------------------------------
// do not edit from here
//----------------------------------------------------

#ifdef CHECK_MEMORY_LEAK
#include <Generic/HashMap.mqh>



class CMemory_Leaks_Checking {
private:
  CHashMap<string,string> map;
public:
  CMemory_Leaks_Checking() {
    //Print ("Constructor CMemory_Leaks_Checking");
    map.Clear();
  }
  ~CMemory_Leaks_Checking() {
    map.Clear();
    //Print ("Destructor CMemory_Leaks_Checking");
  }

  void mynew (const string fname, const int lineno, const void *ptr, const string type) {
    string desc = StringFormat("%x",ptr);
    string info = StringFormat ("File %s line %d: desc %s type %s", fname, lineno, desc, type);
    if (!map.Add (desc, info)) {
      Print (StringFormat ("%s ERROR map.Add", __FUNCTION__));
      return;
    }
  }

  void mydelete (const void *ptr) {
    string desc = StringFormat("%x",ptr);
    if (!map.ContainsKey(desc)) {
      Print (StringFormat ("%s ERROR map does not contain %s", __FUNCTION__, desc));
      return;
    }
    map.Remove (desc);
  }

  void Resume(void) {
    Print ("-- Resume Memory Leaks --");
    string desc[], infos[];
    ArrayFree (desc);
    ArrayFree (infos);
    map.CopyTo (desc,infos);
    int size=ArraySize(desc);
    if (size == 0) {
      Print ("  no memory leaks");
    } else {
      Print (StringFormat ("%d undeleted objects left", size));
      for (int i=0; i<size; i++) {
	Print (StringFormat ("%s", infos[i]));
      }
    }
    Print ("-- End Resume --");
  }
};

/*************************************/
CMemory_Leaks_Checking memleak_mem_instance;

#define NEW_00(ptr,classe)	                	        \
  ptr = new classe;                                             \
  memleak_mem_instance.mynew (__FILE__,__LINE__,ptr,#classe);
#define NEW_0(ptr,classe)	                	        \
  ptr = new classe();                                           \
  memleak_mem_instance.mynew (__FILE__,__LINE__,ptr,#classe);
#define NEW_1(ptr,classe,p1)                                    \
  ptr = new classe(p1);                                         \
  memleak_mem_instance.mynew (__FILE__,__LINE__,ptr,#classe);
#define NEW_2(ptr,classe,p1,p2)		         	        \
  ptr = new classe(p1,p2);				        \
  memleak_mem_instance.mynew (__FILE__,__LINE__,ptr,#classe);
#define NEW_3(ptr,classe,p1,p2,p3)		 	        \
  ptr = new classe(p1,p2,p3);					\
  memleak_mem_instance.mynew (__FILE__,__LINE__,ptr,#classe);
#define NEW_4(ptr,classe,p1,p2,p3,p4)		 	        \
  ptr = new classe(p1,p2,p3,p4);				\
  memleak_mem_instance.mynew (__FILE__,__LINE__,ptr,#classe);
/* .....
 * can easily be extended
 */


#define DELETE(ptr)       \
  delete ptr;             \
  memleak_mem_instance.mydelete (ptr);

#define MEMORY_RESUME memleak_mem_instance.Resume();




#else  // #ifdef CHECK_MEMORY_LEAK
#define NEW_00(ptr,classe)            ptr = new classe;
#define NEW_0(ptr,classe)             ptr = new classe();
#define NEW_1(ptr,classe,p1)          ptr = new classe(p1);
#define NEW_2(ptr,classe,p1,p2)       ptr = new classe(p1,p2);
#define NEW_3(ptr,classe,p1,p2,p3)    ptr = new classe(p1,p2,p3);
#define NEW_4(ptr,classe,p1,p2,p3,p4) ptr = new classe(p1,p2,p3,p4);

#define DELETE(ptr) delete ptr;

#define MEMORY_RESUME

#endif // #ifdef CHECK_MEMORY_LEAK



#endif // #ifndef MEMLEAK_HEADER
